/* -*- tab-width: 4 -*- */

/*
 *  This header contains various symbolic constants
 *  to be set according to your system configuration.
 *
 *  Read carefully the INSTALL file and exactly know what you do
 *  before any attempts to change them.
 */


/*
 *  Set the following to the path of the _REAL_ sendmail.
 */
#define SENDMAIL "/usr/sbin/sendmail.real"


/*
 *  To add a newline('\n') after the Korean designator,
 *  define NLAFTERDESIG.
 *  Some old versions of hcode need the designator followed by a newline,
 *  and you can ensure that your mails be decoded by them correctly
 *  if you define NLAFTERDESIG.
 *  But then, each of your mail sent will have a blank line just before
 *  the first occurrence of a line containing a Korean character
 *  if the recipient is using a (true) Korean sendmail,
 *  and that may affect the validity of your mail if it is
 *  a program source or pgp-signed.
 */
#undef NLAFTERDESIG


/*
 *  Maximum length of a line.
 *  Lines longer than this may not be converted correctly.
 */
#define MAXLINELEN (1024*1024)


/*
 *  Size of the array used for read/write() buffer.
 *  You don't need to change this usually.
 */
#define BUFFERSIZE 1024


/*
 *  Path of the system-wide configuration file.
 */
#define SYSCFNAME "/etc/kesmpre"


/*
 *  Define NOPROTOS if your compiler doesn't allow prototypes
 *  in function declarations.
 */
#undef NOPROTOS
