/* -*- tab-width: 4 -*- */


#ifndef _HEADER_H_HAS_BEEN_INCLUDED_
#define _HEADER_H_HAS_BEEN_INCLUDED_


#include <unistd.h>
#include <stdio.h>

#include "config.h"


/*
 *  to get rid of prototypes in case of using non-ANSI C compilers
 */
#ifdef NOPROTOS
# define _PRO(protos) ()
#else
# define _PRO(protos) protos
#endif


/*
 *  maximum number of charsets that can be specified.
 */
#define MAXCHARSETS 32

/*
 *  argument of perror()
 */
#define PROGNAME "kesmpre"


#define MAX(a, b) ((a) > (b) ? (a) : (b)) /* obvious */


/*
 *  set to 1 if -bs option is given
 */
extern int use_smtp;

/*
 *  temporary file descriptor and pointer
 */
extern int tmp;
extern FILE *tmpp;

/*
 *  mails in these charsets are iso-2022-kr-encoded.
 */
extern char *charsets[MAXCHARSETS+1];

/*
 *  file pointers to the log files
 */
#ifdef DEBUG
extern FILE *ep;
extern FILE *op;
#endif


pid_t invoke_real_sendmail _PRO((int *, int *, int *, char *[]));
int filter _PRO((int stdinfd, int stdoutfd, int stderrfd));
int maketmpfile _PRO(());
ssize_t writen _PRO((int fd, void *vptr, size_t n));
int putnl _PRO((FILE *fp));
int isin _PRO((char *m, int n, char *a[]));
int memstrcasecmp _PRO((unsigned char *m, int n, unsigned char *s));
char *memcasestr _PRO((unsigned char *m, int n, unsigned char *s));
void perror_exit _PRO((int));


/*
 *  These macros and function are from Jungshik Shin's hmconv 1.0 pl3.
 *  <jungshik@net161-61.student.yale.edu>
 */
#define isksc(c)   ( (unsigned char) (c) > (unsigned char) '\240'   && \
					 (unsigned char)  (c) < (unsigned char) '\377' ) 
#define is7ksc(c)   ( (unsigned char) (c) > (unsigned char) '\040'   && \
					  (unsigned char)  (c) < (unsigned char) '\177' ) 
int convert _PRO((char line[], FILE *out));

/*
 *  This function is from June-Yub Lee's hcode 2.1.
 *  <jylee@math.kaist.ac.kr>
 */  
void string_to_base64 _PRO((FILE *fp, char *ibuf, unsigned length));


#endif /* _HEADER_H_HAS_BEEN_INCLUDED_ */
