/*
 *  This is part of the hmconv Korean mail en/decoder,
 *  modified to be integrated with kesmpre
 *  by Park, Jae-hyon <jhpark@entropy.kaist.ac.kr>.
 */


/* KSC 5601 < - > ISO-2022-KR code converter for Hangul Mail Exchange
   with non-localized MTA(e.g. sendmail )

   version 1.0pl3 ( July 11, 1996) : Thanks to D. Lim,
                                     1. change in cmd line argument parsing
                                     2. more portability issues addressed
                                     3. now exits gracefully as required in 
                                        some OS : 'return(0)' at the end,
                                        which solves problem in Solaris
                                        when used as a filter for Pine.
                      

   version 1.0pl2 ( July  9, 1996) : 1.portability issue related
                                     to 'char' type range addressed.
                                     2. another portability issue
                                     resolved : To compile with
                                     pre-ANSI C compiler, give 
                                     '-DKNR' option at the cmd line
                                     for c compiler or uncomment
                                     '#define KNR'.(See below)
                                     
    

   version 1.0pl1 ( June, 8, 1996) : supercedes one included in hmconv.tar.gz
                                     now is a bit more robust
                                     and works better in Emacs.

   version 1.0    ( May, 1996)

   By Jungshik Shin(jshin@minerva.cis.yale.edu)

   For details on Hangul mail exchange with this filter,
   see documents included in hmconv.tar.gz and
   references there. You may also subscribe to
   han.comp.mail and han.comp.hangul for further
   development in Hangul mail exchange including
   customization for Emacs+Rmail (.emacs setting)
   I plan to post.

*/


#include <stdio.h>
#include <string.h>

#include "header.h"


#define BUF 4096
#define SI '\017'
#define SO '\016'


int ishangul;


#define KSC 1
#define ASCII 0
int convert(line, out)
char line[];
FILE *out;
{

	int mode=ASCII;
	int i=0;
   
	i = 0 ;

	while (  line[i] != '\n' && line[i] != (unsigned char) EOF &&
			 line[i] != '\0'  ) {
		/* the last case for buffer fill or
		   input from emacs which doesn't 
		   pad the region with EOF or '\n' 
		   when handing it over to a filter 
		   ( 'shell-command-on-region) */

        if ( mode == ASCII && isksc(line[i]))  {
         
			fputc(SO,out);
			fputc(0x7f & line[i],out);
			mode = KSC;
        }
        else if ( mode == ASCII && !isksc(line[i]) )
			fputc(line[i],out);
        else if ( mode == KSC && isksc(line[i]) )
			/* else if ( mode == KSC && ( isksc(line[i] || line[i] == ' ' ) ) */
			fputc(0x7f & line[i],out);
        else {
			fputc(SI,out);
			fputc(line[i],out);
			mode = ASCII;
        }
        i++;
	}
	if ( mode == KSC) 
        fputc(SI,out);


	if ( line[i] == '\n'  || ( line[i] == '\0' && i == BUF ) )      
		fputc('\n',out);       

	/* added after testing with emacs.  EOF is added by fclose.    
	   no need to add it manually. '\0' is replaced by '\n' only in 
	   case of buffer fill */
 
    return(0);
}    
