/* -*- tab-width: 4 -*- */

/*
 *  This is part of the hcode Korean code converter,
 *  modified to be integrated with kesmpre
 *  by Park, Jae-hyon <jhpark@entropy.kaist.ac.kr>.
 */


#include <stdio.h>
#include <sys/types.h>


/**** S T R I N G _ T O _ B A S E 6 4 ****/

#define B64_0                   0x0fc0000
#define B64_1                   0x003f000
#define B64_2                   0x0000fc0
#define B64_3                   0x000003f
#define PAD                     64

static char *b64_alphabet =
"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";


void string_to_base64(fp, ibuf, length)
FILE *fp;
char *ibuf;
unsigned length;
{
	register u_long btmp;
	register short int i, count;

	while (length != 0)
	{
		for (i = count = 0, btmp = 0; i < 3; i++)
			if (length != 0)
			{
				btmp = (btmp << 8) | (u_long)(*ibuf++ & 0x0ff);
				length--;
				count++;
			}
			else
				btmp = (btmp << 8) | (u_long)0;

		putc(b64_alphabet[(B64_0 & btmp) >> 18], fp);
		putc(b64_alphabet[(B64_1 & btmp) >> 12], fp);
		putc(b64_alphabet[count >= 2 ? (B64_2 & btmp) >> 6 : PAD], fp);
		putc(b64_alphabet[count == 3 ? (B64_3 & btmp) : PAD], fp);
	}
}  /* end of string_to_base64(). */
