/*  -*- tab-width: 4 -*-  */


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>

#include "header.h"


int tmp;
FILE *tmpp;


static char tmpfilename[L_tmpnam];


void rmtmpfile() { unlink(tmpfilename); }

void signal_handler(sig) int sig; { rmtmpfile(); }

void set_signal_handlers()
{
	signal(SIGINT, signal_handler);
	signal(SIGQUIT, signal_handler);
	signal(SIGTERM, signal_handler);
	signal(SIGHUP, signal_handler);
	signal(SIGSEGV, signal_handler);
}

int maketmpfile()
{
	int fd;

	/* others must not read our tmp file, hence the permission 600. */
	if ((fd = open(tmpnam(tmpfilename), O_RDWR | O_CREAT | O_TRUNC,
				   S_IRUSR | S_IWUSR)) >= 0) {
		atexit(rmtmpfile);
		set_signal_handlers();
	}
	
	return fd;
}


void perror_exit(status)
int status;
{
	perror(PROGNAME);
	exit(status);
}


int memstrcasecmp(m, n, s)
unsigned char *m, *s;
int n;
{
	for (; n > 0 && *s; m++, s++, n--)
		if (tolower(*m) != tolower(*s))
			return tolower(*m) - tolower(*s);

	if (*s)
		return - *s;
	else
		return n;
}

int memcasecmp(m1, n1, m2, n2)
unsigned char *m1, *m2;
int n1, n2;
{
	for (; n1 > 0 && n2 > 0; m1++, m2++, n1--, n2--)
		if (tolower(*m1) != tolower(*m2))
			return tolower(*m1) - tolower(*m2);

	return n1 - n2;
}

char *memcasestr(m, n, s)
unsigned char *m, *s;
int n;
{
	unsigned char *e;
	int l = strlen(s);
	
	if (n >= l)
		for (e = m + n - l + 1; m < e; m++)
			if (strncasecmp(m, s, l) == 0)
				return m;

	return NULL;
}


int isin(m, n, a)
char *m;
int n;
char *a[];
{
	if (m == NULL) {
		m = "NONE";
		n = 4;
	}
	
	for (; *a; a++)
		if (memstrcasecmp(m, n, *a) == 0)
			return 1;			/* (m, n) is in a */

	return 0;
}


int putnl(fp)
FILE *fp;
{
	return fputs(use_smtp ? "\r\n" : "\n", fp);
}
