/*
 *  This function is from Advanced Programming in the UNIX Environment
 *  written by W. Richard Stevens.
 */


#include <unistd.h>


/*
 *  Write "n" bytes to a descriptor.
 */
ssize_t writen(fd, vptr, n)
int fd;
void *vptr;
size_t n;
{
	size_t nleft, nwritten;
	char *ptr;

	ptr = vptr;					/* can't do pointer arithmetic on void* */
	nleft = n;
	while (nleft > 0) {
		if ((nwritten = write(fd, ptr, nleft)) <= 0)
			return nwritten;	/* error */

		nleft -= nwritten;
		ptr += nwritten;
	}

	return n;
}
